@echo off

rem Command "make all" makes all variations:
rem   xxxk_w.exe
rem	 xxx - number of vectors (in 1000s)
rem	 w = n (no prefetch), s (short-174), l (long-348)

rem Command "make pf" makes 100k code for different prefetch lengths
rem   32, 64, 96, 128, 160, 192, 224, 256

if "%1"=="all" goto make_all
if "%1"=="pf" goto make_pf

nasmw -f win32 -o xform.obj xform.asm
cl /Oityb2 /G5 /Gr /Gs test.cpp xform.obj

goto end

:make_all

nasmw -f win32 -o xform.obj xform.asm
cl /Oityb2 /G5 /Gr /Gs /DNUM_VECTORS=100000 /Fe100k_s.exe test.cpp xform.obj

nasmw -f win32 -D NO_PREFETCH -o xform.obj xform.asm
cl /Oityb2 /G5 /Gr /Gs /DNUM_VECTORS=100000 /Fe100k_n.exe test.cpp xform.obj

nasmw -f win32 -D PREFETCH_DISTANCE=348 -o xform.obj xform.asm
cl /Oityb2 /G5 /Gr /Gs /DNUM_VECTORS=100000 /Fe100k_l.exe test.cpp xform.obj

nasmw -f win32 -o xform.obj xform.asm
cl /Oityb2 /G5 /Gr /Gs /DNUM_VECTORS=1000 /Fe001k_s.exe test.cpp xform.obj

nasmw -f win32 -D NO_PREFETCH -o xform.obj xform.asm
cl /Oityb2 /G5 /Gr /Gs /DNUM_VECTORS=1000 /Fe001k_n.exe test.cpp xform.obj

nasmw -f win32 -D PREFETCH_DISTANCE=348 -o xform.obj xform.asm
cl /Oityb2 /G5 /Gr /Gs /DNUM_VECTORS=1000 /Fe001k_l.exe test.cpp xform.obj

goto end

:make_pf

nasmw -f win32 -D PREFETCH_DISTANCE=32 -o xform.obj xform.asm
cl /Oityb2 /G5 /Gr /Gs /DNUM_VECTORS=100000 /DSET_PRIORITY /Fe032.exe test.cpp xform.obj

nasmw -f win32 -D PREFETCH_DISTANCE=64 -o xform.obj xform.asm
cl /Oityb2 /G5 /Gr /Gs /DNUM_VECTORS=100000 /DSET_PRIORITY /Fe064.exe test.cpp xform.obj

nasmw -f win32 -D PREFETCH_DISTANCE=96 -o xform.obj xform.asm
cl /Oityb2 /G5 /Gr /Gs /DNUM_VECTORS=100000 /DSET_PRIORITY /Fe096.exe test.cpp xform.obj

nasmw -f win32 -D PREFETCH_DISTANCE=128 -o xform.obj xform.asm
cl /Oityb2 /G5 /Gr /Gs /DNUM_VECTORS=100000 /DSET_PRIORITY /Fe128.exe test.cpp xform.obj

nasmw -f win32 -D PREFETCH_DISTANCE=160 -o xform.obj xform.asm
cl /Oityb2 /G5 /Gr /Gs /DNUM_VECTORS=100000 /DSET_PRIORITY /Fe160.exe test.cpp xform.obj

nasmw -f win32 -D PREFETCH_DISTANCE=192 -o xform.obj xform.asm
cl /Oityb2 /G5 /Gr /Gs /DNUM_VECTORS=100000 /DSET_PRIORITY /Fe192.exe test.cpp xform.obj

nasmw -f win32 -D PREFETCH_DISTANCE=224 -o xform.obj xform.asm
cl /Oityb2 /G5 /Gr /Gs /DNUM_VECTORS=100000 /DSET_PRIORITY /Fe224.exe test.cpp xform.obj

nasmw -f win32 -D PREFETCH_DISTANCE=256 -o xform.obj xform.asm
cl /Oityb2 /G5 /Gr /Gs /DNUM_VECTORS=100000 /DSET_PRIORITY /Fe256.exe test.cpp xform.obj

:end

erase test.obj
erase xform.obj
